select
  an.numero as numero_matriz
  , (select descricao from sp_grupoanimalespecifico(current_date
    , (select valor from configuracao where nome = 'TipoGrupoPrincipal'), an.cdanimal)) as grupo_local
  , (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue
  , (select (sp1.anos || ' ano(s) ' || sp1.meses || ' mes(s) ' || sp1.dias || ' dia(s)')
            from sp_idadeanimal ('', 'where cdanimal = ' || an.cdanimal) sp1) as idade
  , an.dtnascimento
  , (case when te.cdreproducao is null then 'No'
    else 'Sim' end) as te
  , (case cat.creprodutiva
        when 1 then 'Insem./Cob.'
        when 2 then 'Implant.'
        when 3 then 'Gestante'
        when 4 then 'Vazia' || ': ' || (case cat.sreprodutiva
                                            when 1 then 'Apta'
                                            when 2 then 'Atrasada'
                                            when 3 then 'PEV'
                                            else cat.sreprodutiva end)
        else cat.creprodutiva end) as status_reprodutivo
  , ((select count(*) from lactacao re where re.cdanimal = an.cdanimal) + + coalesce(an.numpartoentrada,0)) as num_ord_lact_avaliada
  , ultpar.data as data_ultimo_parto
  , (current_date - lac.dtinicio) as del_em_relacao_data_atual
  , (case when (catrep.cdcategoria = 3) then (diagp.dtpartoprovavel) else null end) as data_parto_previsto
  , (case when (catrep.cdcategoria = 3) then
            (diagp.dtpartoprovavel - cast((select valor from configuracao where upper(nome) = 'PERIODODESCANSO') as integer))
            else null end) as data_secagem_prevista
  , ccs.dtanaliseleite as data_ultima_ccs
  , ccs.ccs as ultima_ccs
  , ccs2.dtanaliseleite as data_penultima_ccs
  , ccs2.ccs as penultima_ccs
  , ccs3.dtanaliseleite as data_antepenultima_ccs
  , ccs3.ccs as antepenultima_ccs
  , le.dtleite as dt_ultimo_leite
  , le.pesototal as ultimo_leite
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2)))) else null end) as Mast_clinica_AD_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ad in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ad in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ad in (0,1,2))))
            else null end) as Mast_clinica_AD_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.ad = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_AD
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2)))) else null end) as Mast_clinica_AE_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ae in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.ae in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.ae in (0,1,2))))
            else null end) as Mast_clinica_AE_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.ae = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_AE
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2)))) else null end) as Mast_clinica_PD_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pd in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pd in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pd in (0,1,2))))
            else null end) as Mast_clinica_PD_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.pd = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_PD
  , (case when (((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2)))) > 0)
            then ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2)))) else null end) as Mast_clinica_PE_dias_com_grumos
  , (case when ((select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pe in (0,1,2)))) > 0)
            then (select count(*) from mamite re where re.cdanimal = lac.cdanimal and (re.data between lac.dtinicio and current_date) and (re.pe in (0,1,2))
                        and not exists (select * from mamite re2 where re2.cdanimal = re.cdanimal and (re2.data between (re.data - 14) and (re.data - 1)) and (re2.pe in (0,1,2))))
            else null end) as Mast_clinica_PE_caso_14_dias_dif
  , (case when ((select count(*) from escoreteto ead where ead.cdanimal = lac.cdanimal and (ead.data between lac.dtinicio and current_date) and ead.pe = 0) > 0)
            then (1)
            else null end) as Lan_escore_teto_perdido_PE
  , cult1.data as dt_primeiro_cultivo
  , (case when (cult1.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo1) else null end) as Resultado_1_primeiro_cultivo
  , (case when (cult1.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult1.cdmicroorganismo2) else null end) as Resultado_2_primeiro_cultivo
  , cult2.data as dt_segundo_cultivo
  , (case when (cult2.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo1) else null end) as Resultado_1_segundo_cultivo
  , (case when (cult2.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult2.cdmicroorganismo2) else null end) as Resultado_2_segundo_cultivo
  , cult3.data as dt_terceiro_cultivo
  , (case when (cult3.cdmicroorganismo1 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult3.cdmicroorganismo1) else null end) as Resultado_1_terceiro_cultivo
  , (case when (cult3.cdmicroorganismo2 is not null)
            then (select nome from microorganismo where cdmicroorganismo = cult3.cdmicroorganismo2) else null end) as Resultado_2_terceiro_cultivo
  , (case cad.ad
    when 0 then 'Negarivo'
    when 1 then 'Traos'
    when 2 then '1+'
    when 3 then '2+'
    when 4 then '3+'
    else NULL end) as CMT_AD
  , cad.data as CMT_AD_DATA
  , (case cae.ae
    when 0 then 'Negarivo'
    when 1 then 'Traos'
    when 2 then '1+'
    when 3 then '2+'
    when 4 then '3+'
    else NULL end) as CMT_AE
  , cae.data as CMT_AE_DATA
  , (case cpd.pd
    when 0 then 'Negarivo'
    when 1 then 'Traos'
    when 2 then '1+'
    when 3 then '2+'
    when 4 then '3+'
    else NULL end) as CMT_PD
  , cpd.data as CMT_PD_DATA
  , (case cpe.pe
    when 0 then 'Negarivo'
    when 1 then 'Traos'
    when 2 then '1+'
    when 3 then '2+'
    when 4 then '3+'
    else NULL end) as CMT_PE
  , cpe.data as CMT_PE_DATA
  , (case
    when pa1.cdprincipioativo is not null and pa2.cdprincipioativo is not null and pa3.cdprincipioativo is not null then pa1.nome || ' / ' || pa2.nome || ' / ' ||pa3.nome
    when pa1.cdprincipioativo is not null and pa2.cdprincipioativo is not null then pa1.nome || ' / ' || pa2.nome
    when pa1.cdprincipioativo is not null then pa1.nome
    else NULL end) as tratamento
  , '' as decisao
  , p2.peso as penultimo_peso
  , p2.dtpeso as penultimo_peso_data
  , p1.peso as ultimo_peso
  , p1.dtpeso as ultimo_peso_data
  , ecc2.valor as penultimo_ecc
  , ecc1.valor as ultimo_ecc
  , (select producao305 from sp_producao305(lac.cdlactacao)) as producao_estimada_305
from
  animal an
  join lactacao lac on lac.cdanimal = an.cdanimal and lac.dtfim is null
  join sp_categoriaanimal (current_date, '') cat on cat.animal = an.cdanimal
  join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
  join categoria catrep on catrep.cdcategoria =
    (select sp.creprodutiva from sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp)
  left join reproducao diagp on diagp.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.diagnostico = 'P' order by re.data desc)
  left join analiseleite ccs on ccs.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 order by re.dtanaliseleite desc)
  left join analiseleite ccs2 on ccs2.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs.dtanaliseleite order by re.dtanaliseleite desc)
  left join analiseleite ccs3 on ccs3.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = lac.cdanimal and re.dtanaliseleite >= lac.dtinicio and re.ccs > 0 and re.dtanaliseleite < ccs2.dtanaliseleite order by re.dtanaliseleite desc)
  left join leite le on le.cdleite =
    (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.dtleite desc)
  left join mamite cult1 on cult1.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null)) order by re.data asc)
  left join mamite cult2 on cult2.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult1.data order by re.data asc)
  left join mamite cult3 on cult3.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = lac.cdanimal and re.data >= lac.dtinicio and ((re.cdmicroorganismo1 is not null) or (re.cdmicroorganismo2 is not null))
            and re.data > cult2.data order by re.data asc)
  left join cmt cad on cad.cdcmt =
    (select first 1 c.cdcmt from cmt c where c.cdanimal = an.cdanimal and c.data > lac.dtinicio and c.ad is not null order by c.data desc)
  left join cmt cae on cae.cdcmt =
    (select first 1 c.cdcmt from cmt c where c.cdanimal = an.cdanimal and c.data > lac.dtinicio and c.ae is not null order by c.data desc)
  left join cmt cpd on cpd.cdcmt =
    (select first 1 c.cdcmt from cmt c where c.cdanimal = an.cdanimal and c.data > lac.dtinicio and c.pd is not null order by c.data desc)
  left join cmt cpe on cpe.cdcmt =
    (select first 1 c.cdcmt from cmt c where c.cdanimal = an.cdanimal and c.data > lac.dtinicio and c.pe is not null order by c.data desc)
  left join cmt ct on ct.cdcmt =
    (select first 1 c.cdcmt from cmt c where c.cdanimal = an.cdanimal and c.data > lac.dtinicio and c.cdtratamentobase is not null order by c.data desc)
  left join tratamentobase trata on trata.cdtratamentobase = ct.cdtratamentobase
  left join principioativo pa1 on pa1.cdprincipioativo = trata.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = trata.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = trata.cdprincipioativo3
  left join peso p1 on p1.cdpeso =
    (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal order by p.dtpeso desc)
  left join peso p2 on p2.cdpeso =
    (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal and p.cdpeso <> p1.cdpeso order by p.dtpeso desc)
  left join medida ecc1 on ecc1.cdmedida =
    (select first 1 m.cdmedida from medida m where m.cdanimal = an.cdanimal and m.cdtipomedida = 2 order by m.dtmedida desc)
  left join medida ecc2 on ecc2.cdmedida =
    (select first 1 m.cdmedida from medida m where m.cdanimal = an.cdanimal and m.cdtipomedida = 2 and m.dtmedida < ecc1.dtmedida order by m.dtmedida desc)
  left join reproducao te on te.cdembriao = an.cdanimal
where
  an.dtbaixa is null
order by an.numordenado
